<template>
  <div class="time-line">
    <div class="bonus position-relative" v-for="(bonus, index) in bonuses" :key="bonus.id" :class="{ 'is-current' : bonus.isActive }">
      <div class="top">
        <span class="percent text-right">{{ getPercent(bonus) }}</span>
        <span class="circle"></span>
        <span class="time">{{ formatDate(bonus) }}</span>
      </div>
      <div class="content">
        <span v-if="bonus.timestamp < now || bonus.isActive">{{solds[bonus.timestamp] | formatCurrencyAmount('HETA', '0') }} HETA token sold</span>
      </div>
      <div class="line position-absolute" :class="{ 'is-prev' : bonuses[index + 1] && bonuses[index + 1].isActive }"></div>
    </div>
  </div>
</template>

<script>
import moment from 'moment';
import BigNumber from 'bignumber.js';
import { mapState } from 'vuex';

import rf from '../../../common/requests/RequestFactory';

export default {
  props: {
    solds: {
      type: Object,
    }
  },
  data () {
    return {
      now: moment().valueOf(),
    };
  },
  computed: {
    ...mapState([
      'bonuses',
    ]),
  },
  methods: {
    getPercent (bonus) {
      return `${BigNumber(bonus.percent).multipliedBy(100).toString()}%`;
    },
    formatDate (bonus) {
      const time = moment(bonus.timestamp).utcOffset(1);
      return `${time.format('h A')} ${time.format('YYYY/MM/DD')} GMT +1`;
    },
  },
}
</script>

<style lang="scss" scoped>
  @import '../../../../sass/mobile/typoVariables';
  .time-line {
    // temporary
    width: 100%;
    position: relative;
    z-index: 100;
    @extend .Medium-14;
    padding: 18rem 17rem 0;
    .bonus {
      .top {
        .percent {
          @extend .bold-16;
          display: inline-block;
          width: 40rem;
          color: #cacaca;
        }
        .circle {
          display: inline-block;
          height: 9rem;
          width: 9rem;
          margin: 0 12rem 0 15rem;
          background: #2f314e;
          border-radius: 50%;
          position: relative;
          z-index: 2;
        }
        .time {
          @extend .bold-14;
          color: #cacaca;
        }
      }
      .content {
        padding-left: 82rem;
        @extend .Medium-14;
        color: #747474;
        margin-top: -12rem;
        margin-bottom: 14rem;
      }
      .line {
        height: calc(100% + 20rem);
        width: 1rem;
        z-index: 1;
        background: #2f2f54;
        top: 30rem;
        left: 62rem;
      }
      .is-prev {
        background-image: linear-gradient(to top, #da6400, #2f2f54);
      }
    }
    .is-current {
      .top {
        .percent {
          font-size: $big-20;
          color: #fa7300;
          transform: translateY(2rem);
        }
        .circle {
          background: #fa7300;
        }
        .time {
          color: #fa7300;
        }
      }
    }
  }
</style>